package org.commonjava.tensor.inject;

import javax.enterprise.context.ApplicationScoped;
import javax.enterprise.inject.Produces;
import javax.inject.Inject;

import org.apache.maven.graph.spi.effective.EGraphDriver;
import org.commonjava.tensor.io.json.TensorSerializationAdapter;
import org.commonjava.web.json.ser.JsonSerializer;

@ApplicationScoped
public class TensorSerializerProvider
{

    private JsonSerializer serializer;

    @Inject
    private EGraphDriver driver;

    @Produces
    @TensorData
    public synchronized JsonSerializer getTensorSerializer()
    {
        if ( serializer == null )
        {
            serializer = new JsonSerializer( new TensorSerializationAdapter( driver ) );
        }

        return serializer;
    }

}
