package org.commonjava.tensor.io.json;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.List;

import org.apache.maven.graph.effective.ref.EGraphFacts;

import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.JsonPrimitive;
import com.google.gson.JsonSerializationContext;
import com.google.gson.JsonSerializer;

public class EGraphFactsSer
    implements JsonSerializer<EGraphFacts>, JsonDeserializer<EGraphFacts>
{

    @Override
    public EGraphFacts deserialize( final JsonElement src, final Type typeInfo, final JsonDeserializationContext ctx )
        throws JsonParseException
    {
        final JsonObject obj = src.getAsJsonObject();
        final JsonElement arrElem = obj.get( SerializationConstants.EPROFILES );

        final List<String> profiles = new ArrayList<String>();
        if ( arrElem != null )
        {
            for ( final JsonElement elem : arrElem.getAsJsonArray() )
            {
                final String profile = elem.getAsString();
                if ( !profiles.contains( profile ) )
                {
                    profiles.add( profile );
                }
            }
        }

        return new EGraphFacts( profiles );
    }

    @Override
    public JsonElement serialize( final EGraphFacts src, final Type typeInfo, final JsonSerializationContext ctx )
    {
        final JsonObject obj = new JsonObject();

        final JsonArray arr = new JsonArray();
        for ( final String profile : src.getActiveProfiles() )
        {
            arr.add( new JsonPrimitive( profile ) );
        }

        obj.add( SerializationConstants.EPROFILES, arr );
        return obj;
    }

}
